VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CLink"
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_Value As Variant
Private m_PrevLink As CLink
Private m_NextLink As CLink
Private m_Children As NList
Private m_Parent As CLink


Public Sub Create(ByVal vValue As Variant, ByVal prev As CLink, ByVal naext As CLink)
    If IsObject(vValue) Then
                Set m_Value = vValue
        Else:   m_Value = vValue
    End If
    Set m_PrevLink = prev
    Set m_NextLink = naext
    If Not m_PrevLink Is Nothing Then Set m_PrevLink.NextLink = Me
    If Not m_NextLink Is Nothing Then Set m_NextLink.PrevLink = Me
End Sub
Public Sub Dispose()
    If Not m_Children Is Nothing Then
        m_Children.Dispose
    End If
    Set m_Children = Nothing
    Set m_Parent = Nothing
    Set m_PrevLink = Nothing
    Set m_NextLink = Nothing
End Sub
Public Property Get Value() As Variant
    If IsObject(m_Value) Then
                Set Value = m_Value
        Else:   Value = m_Value
    End If
End Property
Public Property Let Value(ByVal vValue As Variant)
    m_Value = vValue
End Property
Public Property Set Value(ByVal vValue As Variant)
    Set m_Value = vValue
End Property
Public Property Get PrevLink() As CLink
    Set PrevLink = m_PrevLink
End Property
Public Property Set PrevLink(ByVal prev As CLink)
    Set m_PrevLink = prev
End Property
Public Property Get NextLink() As CLink
    Set NextLink = m_NextLink
End Property
Public Property Set NextLink(ByVal naext As CLink)
    Set m_NextLink = naext
End Property
Public Property Get Parent() As CLink
    Set Parent = m_Parent
End Property
Public Sub SetParent(ByVal mom As CLink)
    Set m_Parent = mom
End Sub
Public Property Get Children() As NList
    If m_Children Is Nothing Then
        Set m_Children = New NList
        m_Children.SetParent Me
    End If
    Set Children = m_Children
End Property
Public Property Get Level() As Long
    Dim lnk As CLink: Set lnk = Me.Parent
    Do Until lnk Is Nothing
        Level = Level + 1
        Set lnk = lnk.Parent
    Loop
End Property
Public Function GetPathList() As NList
    Set GetPathList = New NList
    Dim lnk As CLink: Set lnk = Me
    Do Until lnk Is Nothing
        GetPathList.Insert lnk.Value, GetPathList.LowerBound
        Set lnk = lnk.Parent
    Loop
End Function


'Private Sub Class_Terminate()
'    Debug.Print "Terminate: " & Me.Value
'End Sub
