VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "NListWalker"
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_List As NList
Private m_Current As CLink


Public Sub Attach(ByVal lst As NList)
    Set m_List = lst
End Sub
Public Sub Dispose()
    Set m_List = Nothing
    Set m_Current = Nothing
End Sub


Public Function MoveNext() As Boolean
    If m_List Is Nothing Then Err.Raise 5
    If m_Current Is Nothing Then
            Set m_Current = m_List.First
        Else
            Set m_Current = m_Current.NextLink
    End If
    MoveNext = Not (m_Current Is Nothing)
End Function
Public Function MovePrevious() As Boolean
    If m_List Is Nothing Then Err.Raise 5
    If m_Current Is Nothing Then
            Set m_Current = m_List.Last
        Else
            Set m_Current = m_Current.PrevLink
    End If
    MovePrevious = Not (m_Current Is Nothing)
End Function
Public Property Get Current() As CLink
    Set Current = m_Current
End Property
Public Sub Reset()
    Set m_Current = Nothing
End Sub
Public Function Clone() As NListWalker
    Err.Raise 5, , "Not implemented"
End Function


