Attribute VB_Name = "MTestList"
Option Explicit


Sub TestLinks()
    Dim lst As NList: Set lst = New NList: lst.LowerBound = 1
    Dim lst2 As NList
    lst.Create "Eins", "Zwei", "Drei":
    lst.Insert "Joe", 4
'    lst.RemoveAt 4
'    Set lst2 = lst.Copy(3, 4)
'    lst.RemoveSpan 1, 4
'    lst.ShiftSpan 3, 4, 0
'    lst.Reverse

    DumpList lst
    lst.Dispose
End Sub

Sub DumpList(ByVal lst As NList)
    Dim i As Long, sPrev As String, sNext As String, sFirst As String, sLast As String
    Debug.Print: Debug.Print "<list dump>"
    Debug.Print "Count: " & lst.Count & " (" & lst.LowerBound & " to " & lst.UpperBound & ")"
    If Not lst.First Is Nothing Then sFirst = lst.First.Value Else sFirst = "(none)"
    If Not lst.Last Is Nothing Then sLast = lst.Last.Value Else sLast = "(none)"
    Debug.Print "First: " & sFirst
    Debug.Print "Last: " & sLast
    For i = lst.LowerBound To lst.UpperBound
        With lst.Item(i)
            If Not .PrevLink Is Nothing Then sPrev = .PrevLink.Value Else sPrev = "(none)"
            If Not .NextLink Is Nothing Then sNext = .NextLink.Value Else sNext = "(none)"
            Debug.Print "#" & i & ":"; Tab(10); sPrev; Tab(20); "<- "; Tab(25); .Value; Tab(30); " ->"; Tab(35); sNext
        End With
    Next i
    Debug.Print "</list dumb>": Debug.Print
End Sub
Sub WalkList(ByVal lst As NList, Optional ByVal fBackwards As Boolean = False)
    Dim walker As NListWalker: Set walker = lst.GetEnumerator
    If fBackwards = False Then
        Do While walker.MoveNext = True
            Debug.Print walker.Current.Value
        Loop
    Else
        Do While walker.MovePrevious = True
            Debug.Print walker.Current.Value
        Loop
    End If
    walker.Dispose
End Sub
