VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "NTree"
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_Root As CLink


Public Sub Create(ByVal vRootValue As Variant)
    Set m_Root = New CLink
    m_Root.Create vRootValue, Nothing, Nothing
End Sub
Public Sub Dispose()
    If Not m_Root Is Nothing Then
        m_Root.Dispose
        Set m_Root = Nothing
    End If
End Sub


Public Property Get Root() As CLink
    Set Root = m_Root
End Property
Public Property Get Count() As Long
    With Me.GetEnumerator
        Do While .MoveAll = True
            Count = Count + 1
        Loop
    End With
End Property
Public Property Get Depth() As Long
    Dim nLevel As Long
    With Me.GetEnumerator
        Do While .MoveAll = True
            nLevel = .Current.Level
            If nLevel > Depth Then Depth = nLevel
        Loop
    End With
End Property
Public Function GetCountAtLevel(ByVal nLevel As Long)
    With Me.GetEnumerator
        Do While .MoveAtLevel(nLevel) = True
            GetCountAtLevel = GetCountAtLevel + 1
        Loop
    End With
End Function
Public Function GetEnumerator() As NTreeWalker
    Set GetEnumerator = New NTreeWalker
    GetEnumerator.Attach Me
End Function
